﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using DataLoader.Common.Model;

namespace DataLoader
{
    class TableParse
    {
        public List<string> ParsePatientRPCData(DataTable table, DataRow row)
        {
            bool check = false;
            bool flag = false;
            string name = "";
            Column column = new Column();
            PntMapping pntmap = new PntMapping();
            List<string> patient = new List<string>();
            patient.Add("TEMPLATE^DEFAULT");
            patient.Add("IMP_TYPE^I");
            // check column definitions
            int colcnt = 0;
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.PatientColumnArraySet(col.ToString(), colcnt);
            }
            //build RPC list
            colcnt = 0;
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ColumnCheck(colcnt);
                if (check == true)
                {
                    string param = pntmap.ExcellMapping(column.ColumnArray[colcnt]);
                    if (param != "skip")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        if (param == "CASE" && stuff.Length >0)
                        {
                            Case.CaseName = stuff;
                            flag = true;
                            stuff = "";
                        }
                        if (stuff.Length>0)
                        {
                            flag = true;
                            if (param == "NAME")
                            {
                                if (column.ColumnArray[colcnt] == "Last name" && stuff.Length > 0)
                                {
                                    name = stuff;
                                }
                                if (column.ColumnArray[colcnt] == "First name" && stuff.Length > 0)
                                {
                                    name = name + "," + stuff;
                                    if (name != null)
                                        patient.Add("NAME^" + name);
                                }
                            }
                            else
                            {
                                patient.Add(param + "^" + stuff);
                            }
                        }
                    }
                }
            }
            if (flag == false)
            {
                patient.Clear();
                patient.Add("-1");
            }
            return patient;
        }

        public List<string> ParseApptRPCData(DataTable table, DataRow row, PatientList pntlist)
        {
            bool check = false;
            Column column = new Column();
            ApptMapping apptmap = new ApptMapping();
            List<string> appt = new List<string>();
            int colcnt = 0;
            string ssn = "";
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ApptColumnArraySet(col.ToString(), colcnt);
            }
            //build RPC list
            colcnt = 0;
            bool flag = false;
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ColumnCheck(colcnt);
                if (check == true)
                {
                    string param = apptmap.ExcellMapping(column.ColumnArray[colcnt]);
                    if (param == "CASE")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        foreach (Patient pnt in pntlist)
                        {
                            if (pnt.CaseName == stuff && stuff.Length>0)
                            {
                                appt.Add("PATIENT^" + pnt.SSN);
                                ssn = pnt.SSN;
                                flag = true;
                                break;
                            }
                        }
                        param = "skip";
                    }
                    if (param == "PATIENT")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        if (stuff.Length == 9)
                            flag = true;
                        if (stuff.Length != 9)
                        {
                            if (ssn != "") row[col] = ssn;
                        }
                    }
                    if (param != "skip")
                    {
                        string stuff = row[col].ToString();
                        if (stuff != null && stuff.Length > 0)
                        {
                            stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                            //if (param == "ADATE")
                                //if (stuff.IndexOf(" ") != -1)
                                    //stuff = stuff.Substring(0, (stuff.IndexOf(" ")));
                            appt.Add(param + "^" + stuff);
                        }
                    }
                }
            }
            if (flag == false)
            {
                appt.Clear();
                appt.Add("-1");
            }
            return appt;
        }

        public List<string> ParseProbRPCData(DataTable table, DataRow row, PatientList pntlist)
        {
            bool check = false;
            Column column = new Column();
            ProblemMapping probmap = new ProblemMapping();
            List<string> prob = new List<string>();
            int colcnt = 0;
            string ssn = "";
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ProbColumnArrarySet(col.ToString(), colcnt);
            }
            //build RPC list
            colcnt = 0;
            bool flag = false;
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ColumnCheck(colcnt);
                if (check == true)
                {
                    string param = probmap.ExcellMapping(column.ColumnArray[colcnt]);
                    if (param == "CASE")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        foreach (Patient pnt in pntlist)
                        {
                            if (pnt.CaseName == stuff && stuff.Length > 0)
                            {
                                prob.Add("PAT_SSN^" + pnt.SSN);
                                ssn = pnt.SSN;
                                flag = true;
                                break;
                            }
                        }
                        param = "skip";
                    }
                    if (param == "PAT_SSN")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        if (stuff.Length == 9)
                            flag = true;
                        if (stuff.Length != 9)
                        {
                            if (ssn != "") row[col] = ssn;
                        }
                    }
                    //
                    if (param != "skip")
                    {
                        string stuff = row[col].ToString();
                        if (stuff != null && stuff.Length > 0)
                        {
                            stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                            //if (param == "ONSET")
                                //if (stuff.IndexOf(" ") != -1)
                                    //stuff = stuff.Substring(0, (stuff.IndexOf(" ")));
                            prob.Add(param + "^" + stuff);
                        }
                    }
                }
            }
            if (flag == false)
            {
                prob.Clear();
                prob.Add("-1");
            }
            return prob;
        }

        public List<string> ParseVitalRPCData(DataTable table, DataRow row, PatientList pntlist)
        {
            bool check = false;
            Column column = new Column();
            VitalMapping vitalmap = new VitalMapping();
            List<string> vital = new List<string>();
            string rate = "";
            int colcnt = 0;
            string ssn = "";
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.VitalColumnArraySet(col.ToString(), colcnt);
            }
            //build RPC list
            colcnt = 0;
            bool flag = false;
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ColumnCheck(colcnt);
                if (check == true)
                {
                    string param = vitalmap.ExcellMapping(column.ColumnArray[colcnt]);
                    if (param == "CASE")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        foreach (Patient pnt in pntlist)
                        {
                            if (pnt.CaseName == stuff && stuff.Length > 0)
                            {
                                vital.Add("PAT_SSN^" + pnt.SSN);
                                ssn = pnt.SSN;
                                flag = true;
                                break;
                            }
                        }
                        param = "skip";
                    }
                    if (param == "PAT_SSN")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        if (stuff.Length == 9)
                            flag = true;
                        if (stuff.Length != 9)
                        {
                            if (ssn != "") row[col] = ssn;
                        }
                    }
                    if (param == "RATE")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        if (stuff != null)
                        {
                            if (column.ColumnArray[colcnt] == "Rate 1" && stuff.Length > 0)
                            {
                                rate = stuff;
                            }
                            if (column.ColumnArray[colcnt] == "Rate 2")
                            {
                                if (stuff.Length > 0)
                                    rate = rate + "/" + stuff;
                                if (rate != null)
                                    vital.Add("RATE^" + rate);
                            }
                        }
                    }
                    else
                    {
                        if (param != "skip")
                        {
                            string stuff = row[col].ToString();
                            if (stuff != null && stuff.Length > 0)
                            {
                                stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                                //if (param == "DT_TAKEN")
                                    //if (stuff.IndexOf(" ") != -1)
                                        //stuff = stuff.Substring(0, (stuff.IndexOf(" ")));
                                vital.Add(param + "^" + stuff);
                            }
                        }
                    }
                }
            }
            if (flag == false)
            {
                vital.Clear();
                vital.Add("-1");
            }
            return vital;
        }

        public List<string> ParseAllergyRPCData(DataTable table, DataRow row, PatientList pntlist)
        {
            bool check = false;
            Column column = new Column();
            AllergyMapping alergmap = new AllergyMapping();
            List<string> allergy = new List<string>();
            int colcnt = 0;
            string ssn = "";
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.AllergyColumnArraySet(col.ToString(), colcnt);
            }
            //build RPC list
            colcnt = 0;
            bool flag = false;
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ColumnCheck(colcnt);
                if (check == true)
                {
                    string param = alergmap.ExcellMapping(column.ColumnArray[colcnt]);
                    if (param == "CASE")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        foreach (Patient pnt in pntlist)
                        {
                            if (pnt.CaseName == stuff && stuff.Length > 0)
                            {
                                allergy.Add("PAT_SSN^" + pnt.SSN);
                                ssn = pnt.SSN;
                                allergy.Add("HISTORIC^1");
                                flag = true;
                                break;
                            }
                        }
                        param = "skip";
                    }
                    if (param == "PAT_SSN")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        if (stuff.Length == 9)
                        {
                            flag = true;
                            allergy.Add("PAT_SSN^" + stuff);
                            allergy.Add("HISTORIC^1");
                            param = "skip";
                        }
                        if (stuff.Length != 9)
                        {
                            if (ssn != "") row[col] = ssn;
                        }
                    }
                    //
                    if (param != "skip")
                    {
                        string stuff = row[col].ToString();
                        if (stuff != null && stuff.Length > 0)
                        {
                            stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                            //if (param == "ORIG_DATE")
                                //if (stuff.IndexOf(" ") != -1)
                                    //stuff = stuff.Substring(0, (stuff.IndexOf(" ")));
                            allergy.Add(param + "^" + stuff);
                        }
                    }
                }
            }
            if (flag == false)
            {
                allergy.Clear();
                allergy.Add("-1");
            }
            return allergy;
        }

        public List<string> ParseLabRPCData(DataTable table, DataRow row, PatientList pntlist)
        {
            bool check = false;
            Column column = new Column();
            LabMapping labmap = new LabMapping();
            List<string> labs = new List<string>();
            int colcnt = 0;
            string ssn = "";
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.LabColumnArraySet(col.ToString(), colcnt);
            }
            //build RPC list
            colcnt = 0;
            bool flag = false;
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ColumnCheck(colcnt);
                if (check == true)
                {
                    string param = labmap.ExcellMapping(column.ColumnArray[colcnt]);
                    if (param == "CASE")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        foreach (Patient pnt in pntlist)
                        {
                            if (pnt.CaseName == stuff && stuff.Length > 0)
                            {
                                labs.Add("PAT_SSN^" + pnt.SSN);
                                ssn = pnt.SSN;
                                flag = true;
                                break;
                            }
                        }
                        param = "skip";
                    }
                    if (param == "PAT_SSN")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        if (stuff.Length == 9)
                        {
                            flag = true;
                            labs.Add("PAT_SSN^" + stuff);
                            param = "skip";
                        }
                        if (stuff.Length != 9)
                        {
                            if (ssn != "") row[col] = ssn;
                        }
                    }
                    //
                    if (param != "skip")
                    {
                        string stuff = row[col].ToString();
                        if (stuff != null && stuff.Length > 0)
                        {
                            stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                            labs.Add(param + "^" + stuff);
                        }
                    }
                }
            }
            if (flag == false)
            {
                labs.Clear();
                labs.Add("-1");
            }
            return labs;
        }

        public List<string> ParseNoteRPCData(DataTable table, DataRow row, PatientList pntlist)
        {
            bool check = false;
            Column column = new Column();
            NoteMapping notemap = new NoteMapping();
            List<string> notes = new List<string>();
            int colcnt = 0;
            string ssn = "";
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.NoteColumnArraySet(col.ToString(), colcnt);
            }
            //build RPC list
            colcnt = 0;
            bool flag = false;
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ColumnCheck(colcnt);
                if (check == true)
                {
                    string param = notemap.ExcellMapping(column.ColumnArray[colcnt]);
                    if (param == "CASE")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        foreach (Patient pnt in pntlist)
                        {
                            if (pnt.CaseName == stuff && stuff.Length > 0)
                            {
                                notes.Add("PAT_SSN^" + pnt.SSN);
                                ssn = pnt.SSN;
                                flag = true;
                                break;
                            }
                        }
                        param = "skip";
                    }
                    if (param == "PAT_SSN")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        if (stuff.Length == 9)
                        {
                            flag = true;
                            notes.Add("PAT_SSN^" + stuff);
                            param = "skip";
                        }
                        if (stuff.Length != 9)
                        {
                            if (ssn != "") row[col] = ssn;
                        }
                    }
                    //
                    if (param != "skip")
                    {
                        string stuff = row[col].ToString();
                        if (stuff != null && stuff.Length > 0)
                        {
                            stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                            //if (param == "ORIG_DATE")
                            //    if (stuff.IndexOf(" ") != -1)
                            //        stuff = stuff.Substring(0, (stuff.IndexOf(" ")));
                            notes.Add(param + "^" + stuff);
                        }
                    }
                }
            }
            if (flag == false)
            {
                notes.Clear();
                notes.Add("-1");
            }
            return notes;
        }

        public List<string> ParseMedRPCData(DataTable table, DataRow row, PatientList pntlist)
        {
            bool check = false;
            Column column = new Column();
            MedMapping medmap = new MedMapping();
            List<string> meds = new List<string>();
            int colcnt = 0;
            string ssn = "";
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.MedColumnArraySet(col.ToString(), colcnt);
            }
            //build RPC list
            colcnt = 0;
            bool flag = false;
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ColumnCheck(colcnt);
                if (check == true)
                {
                    string param = medmap.ExcellMapping(column.ColumnArray[colcnt]);
                    if (param == "CASE")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        foreach (Patient pnt in pntlist)
                        {
                            if (pnt.CaseName == stuff && stuff.Length > 0)
                            {
                                meds.Add("PAT_SSN^" + pnt.SSN);
                                ssn = pnt.SSN;
                                flag = true;
                                break;
                            }
                        }
                        param = "skip";
                    }
                    if (param == "PAT_SSN")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        if (stuff.Length == 9)
                        {
                            flag = true;
                            meds.Add("PAT_SSN^" + stuff);
                            param = "skip";
                        }
                        if (stuff.Length != 9)
                        {
                            if (ssn != "") row[col] = ssn;
                        }
                    }
                    //
                    if (param != "skip")
                    {
                        string stuff = row[col].ToString();
                        if (stuff != null && stuff.Length > 0)
                        {
                            stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                            meds.Add(param + "^" + stuff);
                        }
                    }
                }
            }
            if (flag == false)
            {
                meds.Clear();
                meds.Add("-1");
            }
            return meds;
        }

        public List<string> ParseConsultRPCData(DataTable table, DataRow row, PatientList pntlist)
        {
            bool check = false;
            Column column = new Column();
            ConsultMapping consultmap = new ConsultMapping();
            List<string> consults = new List<string>();
            int colcnt = 0;
            string ssn = "";
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ConsultColumnArraySet(col.ToString(), colcnt);
            }
            //build RPC list
            colcnt = 0;
            bool flag = false;
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ColumnCheck(colcnt);
                if (check == true)
                {
                    string param = consultmap.ExcellMapping(column.ColumnArray[colcnt]);
                    if (param == "CASE")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        foreach (Patient pnt in pntlist)
                        {
                            if (pnt.CaseName == stuff && stuff.Length > 0)
                            {
                                consults.Add("PAT_SSN^" + pnt.SSN);
                                ssn = pnt.SSN;
                                flag = true;
                                break;
                            }
                        }
                        param = "skip";
                    }
                    if (param == "PAT_SSN")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        if (stuff.Length == 9)
                        {
                            flag = true;
                            consults.Add("PAT_SSN^" + stuff);
                            param = "skip";
                        }
                        if (stuff.Length != 9)
                        {
                            if (ssn != "") row[col] = ssn;
                        }
                    }
                    //
                    if (param != "skip")
                    {
                        string stuff = row[col].ToString();
                        if (stuff != null && stuff.Length > 0)
                        {
                            stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                            consults.Add(param + "^" + stuff);
                        }
                    }
                }
            }
            if (flag == false)
            {
                consults.Clear();
                consults.Add("-1");
            }
            return consults;
        }

        public List<string> ParseRadRPCData(DataTable table, DataRow row, PatientList pntlist)
        {
            bool check = false;
            Column column = new Column();
            RadMapping radmap = new RadMapping();
            List<string> rads = new List<string>();
            int colcnt = 0;
            string ssn = "";
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.RadColumnArraySet(col.ToString(), colcnt);
            }
            //build RPC list
            colcnt = 0;
            bool flag = false;
            foreach (DataColumn col in table.Columns)
            {
                colcnt++;
                check = column.ColumnCheck(colcnt);
                if (check == true)
                {
                    string param = radmap.ExcellMapping(column.ColumnArray[colcnt]);
                    if (param == "CASE")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        foreach (Patient pnt in pntlist)
                        {
                            if (pnt.CaseName == stuff && stuff.Length > 0)
                            {
                                rads.Add("PAT_SSN^" + pnt.SSN);
                                ssn = pnt.SSN;
                                flag = true;
                                break;
                            }
                        }
                        param = "skip";
                    }
                    if (param == "PAT_SSN")
                    {
                        string stuff = row[col].ToString();
                        stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                        if (stuff.Length == 9)
                        {
                            flag = true;
                            rads.Add("PAT_SSN^" + stuff);
                            param = "skip";
                        }
                        if (stuff.Length != 9)
                        {
                            if (ssn != "") row[col] = ssn;
                        }
                    }
                    //
                    if (param != "skip")
                    {
                        string stuff = row[col].ToString();
                        if (stuff != null && stuff.Length > 0)
                        {
                            stuff = stuff.Replace("\r", string.Empty).Replace("\n", string.Empty).Trim();
                            rads.Add(param + "^" + stuff);
                        }
                    }
                }
            }
            if (flag == false)
            {
                rads.Clear();
                rads.Add("-1");
            }
            return rads;
        }
    }
}
